package com.themes.fancy.keyboard.keyboard.view;

import android.annotation.SuppressLint;
import android.graphics.drawable.Drawable;
import android.inputmethodservice.InputMethodService;

import android.media.MediaPlayer;
import android.view.View;
import android.view.inputmethod.EditorInfo;
import android.view.inputmethod.InputConnection;
import android.widget.ImageView;
import android.widget.VideoView;

import androidx.annotation.NonNull;
import androidx.annotation.Nullable;

import com.bumptech.glide.Glide;
import com.bumptech.glide.integration.webp.decoder.WebpDrawable;
import com.bumptech.glide.load.DataSource;
import com.bumptech.glide.load.engine.GlideException;
import com.bumptech.glide.request.RequestListener;
import com.bumptech.glide.request.target.Target;
import com.themes.fancy.keyboard.keyboard.R;
import com.themes.fancy.keyboard.keyboard.helper.ResName;
import com.themes.fancy.keyboard.keyboard.helper.SpSave;
import com.themes.fancy.keyboard.keyboard.code.CusKeyBoard;
import com.themes.fancy.keyboard.keyboard.code.CusKeyBoardView;


import kotlin.Unit;
import kotlin.jvm.functions.Function2;

public class InputService extends InputMethodService implements CusKeyBoardView.OnKeyboardActionListener {


    private MyInputView myInputView;
    private CusKeyBoard mKeyBoard;
    private View parentView;


    private ImageView imBG;
    private VideoView videoView;
    
    private int a = R.xml.a;
    private int b= R.xml.b;
    private int c = R.xml.c;

    @SuppressLint("InflateParams")
    @Override
    public View onCreateInputView() {
        parentView = getLayoutInflater().inflate(R.layout.layout_input_view, null);
        findView();
        return parentView;
    }

    private void findView() {

        imBG = parentView.findViewById(R.id.gif_bg);
        videoView = parentView.findViewById(R.id.video_view);
        mKeyBoard = new CusKeyBoard(this, a);
        myInputView = parentView.findViewById(R.id.custom_input_view);
        myInputView.setEnabled(true);
        myInputView.setPreviewEnabled(false);
        myInputView.setKeyboard(mKeyBoard);
        myInputView.setOnKeyboardActionListener(this);
    }


    @Override
    public void onWindowHidden() {
        super.onWindowHidden();
        if(videoView.isPlaying()){
            videoView.pause();

        }
    }

    @Override
    public void onWindowShown() {
        super.onWindowShown();
        String skinPath = SpSave.INSTANCE.getSkinPath();
        if(skinPath == null || skinPath.isEmpty()){
            myInputView.updateUi();
        }else {
            KeyFunction.INSTANCE.readBgOrVideo(this, new Function2<String, Drawable, Unit>() {
                @Override
                public Unit invoke(String s, Drawable drawable) {
                    if (s != null) {
//                        curMediaPlayer = mediaPlayer;
//                        curMediaPlayer.start();
                        myInputView.setBackground(null);
                        if(s.endsWith(".gif")){
                            imBG.setVisibility(View.VISIBLE);
                            videoView.setVisibility(View.GONE);
                            Glide.with(InputService.this)
                                    .load(s)
                                    .addListener(new RequestListener<Drawable>() {
                                        @Override
                                        public boolean onLoadFailed(@Nullable GlideException e, @Nullable Object model, @NonNull Target<Drawable> target, boolean isFirstResource) {
                                            return false;
                                        }

                                        @Override
                                        public boolean onResourceReady(@NonNull Drawable resource, @NonNull Object model, Target<Drawable> target, @NonNull DataSource dataSource, boolean isFirstResource) {
                                            if (resource instanceof WebpDrawable) {
                                                ((WebpDrawable) resource).setLoopCount(WebpDrawable.LOOP_FOREVER);
                                            }
                                            return false;
                                        }
                                    }).into(imBG) ;
                        }else if(s.endsWith(".mp4")){
                            imBG.setVisibility(View.GONE);
                            videoView.setVisibility(View.VISIBLE);
                            videoView.setVideoPath(s);
                            videoView.start();
                            videoView.setOnPreparedListener(new MediaPlayer.OnPreparedListener() {
                                @Override
                                public void onPrepared(MediaPlayer mp) {
                                    mp.setLooping(true);
                                }
                            });
//                            videoView.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {
//                                @Override
//                                public void onCompletion(MediaPlayer mp) {
//                                    videoView.start();
//                                }
//                            });
                        }



                    } else {
                        myInputView.setBackground(drawable);
                    }
                    myInputView.updateUi();
                    return null;
                }
            });
        }


    }

    @Override
    public void onDestroy() {
        super.onDestroy();
        videoView.stopPlayback();
    }

    @Override
    public void onPress(int primaryCode) {

    }

    @Override
    public void onRelease(int primaryCode) {

    }

    @Override
    public void onKey(int primaryCode, int[] keyCodes) {

        InputConnection curInputConnect = getCurrentInputConnection();
        switch (primaryCode) {
            case ResName.KEY_CODE_DELETE:
                curInputConnect.deleteSurroundingText(1, 0);
                break;
            case ResName.KEY_CODE_SHIFT:
                switchShift();
                break;
            case ResName.KEY_CODE_NUMBER_SHIFT:
            case ResName.KEY_CODE_SYMBOL_SHIFT:
                switchMoreOrNumber();
                break;
            case ResName.KEY_CODE_CHANGE_NUMBER:
            case ResName.KEY_CODE_BACK:
                switchNormalOrNumber();
                break;

            case ResName.KEY_CODE_COMPLETE:
            case ResName.KEY_CODE_CANCEL:
                curInputConnect.performEditorAction(EditorInfo.IME_ACTION_DONE);
                break;
            default:
                String codeToChar = KeyFunction.INSTANCE.primaryCodeToChar(primaryCode);
                curInputConnect.commitText(codeToChar, 1);
                if (myInputView.isLowerCase() == 1) {
                    //自动转小写
                    myInputView.setLowerCase(0);
                    KeyFunction.INSTANCE.keyToLowerCase(mKeyBoard);
                    myInputView.setKeyboard(mKeyBoard);
                }
                break;

        }


    }

    private void switchMoreOrNumber() {
        int mode = myInputView.getMode();
        switch (mode) {
            case 1:
                mKeyBoard = new CusKeyBoard(this, c);
                myInputView.setMode(2);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 2:
                mKeyBoard = new CusKeyBoard(this, b);
                myInputView.setMode(1);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchNormalOrNumber() {
        int mode = myInputView.getMode();
        switch (mode) {
            case 0:
                mKeyBoard = new CusKeyBoard(this, b);
                myInputView.setMode(1);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 1:
            case 2:
                mKeyBoard = new CusKeyBoard(this, a);
                myInputView.setMode(0);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }

    }

    private void switchShift() {
        int lowerCase = myInputView.isLowerCase();
        switch (lowerCase) {
            case 0:
                //当前小写转大写
                myInputView.setLowerCase(1);
                KeyFunction.INSTANCE.keyToUpper(mKeyBoard);
                myInputView.setKeyboard(mKeyBoard);
                break;
            case 1:
                //当前大写转锁定大写
                myInputView.setLowerCase(2);
                break;
            case 2:
                //当前锁定大写转小写
                myInputView.setLowerCase(0);
                KeyFunction.INSTANCE.keyToLowerCase(mKeyBoard);
                myInputView.setKeyboard(mKeyBoard);
                break;
        }
    }


    @Override
    public void onText(CharSequence text) {

    }

    @Override
    public void swipeLeft() {

    }

    @Override
    public void swipeRight() {

    }

    @Override
    public void swipeDown() {

    }

    @Override
    public void swipeUp() {

    }


}
